Botan: Botan::MAC_Filter Class Reference

Botan 1.10.16

Public Member Functions | Protected Member Functions | List of all members
Botan::MAC_Filter Class Reference

`#include <filters.h>`

Inheritance diagram for Botan::MAC_Filter:

## Public Member Functions
virtual bool | attachable ()
void | end_msg ()
| MAC_Filter (MessageAuthenticationCode *mac_obj, size_t out_len=0)
| MAC_Filter (MessageAuthenticationCode *mac_obj, const SymmetricKey &key, size_t out_len=0)
| MAC_Filter (const std::string &mac, size_t len=0)
| MAC_Filter (const std::string &mac, const SymmetricKey &key, size_t len=0)
std::string | name () const
virtual void | set_iv (const InitializationVector &iv)
void | set_key (const SymmetricKey &key)
virtual void | start_msg ()
virtual bool | valid_iv_length (size_t length) const
bool | valid_keylength (size_t length) const
void | write (const byte input[], size_t len)
| ~MAC_Filter ()

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

MessageAuthenticationCode Filter.

Definition at line 142 of file filters.h.

## Constructor & Destructor Documentation

## ◆ MAC_Filter() [1/4]

Botan::MAC_Filter::MAC_Filter | ( | MessageAuthenticationCode * | mac_obj,
|  | size_t | out_len = `0`
| ) |  |
| inline

Construct a MAC filter. The MAC key will be left empty.

Parameters

  mac_obj | the MAC to use
  out_len | the output length of this filter. Leave the default value 0 if you want to use the full output of the MAC. Otherwise, specify a smaller value here so that the output of the MAC will be cut off.

Definition at line 172 of file filters.h.

173 : OUTPUT_LENGTH(out_len)
174 {
175 mac = mac_obj;
176 }

## ◆ MAC_Filter() [2/4]

Botan::MAC_Filter::MAC_Filter | ( | MessageAuthenticationCode * | mac_obj,
|  | const SymmetricKey & | key,
|  | size_t | out_len = `0`
| ) |  |
| inline

Construct a MAC filter.

Parameters

  mac_obj | the MAC to use
  key | the MAC key to use
  out_len | the output length of this filter. Leave the default value 0 if you want to use the full output of the MAC. Otherwise, specify a smaller value here so that the output of the MAC will be cut off.

Definition at line 187 of file filters.h.

189 : OUTPUT_LENGTH(out_len)
190 {
191 mac = mac_obj;
192 mac->set_key(key);
193 }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ MAC_Filter() [3/4]

Botan::MAC_Filter::MAC_Filter | ( | const std::string & | mac,
|  | size_t | len = `0`
| ) |  |

Construct a MAC filter. The MAC key will be left empty.

Parameters

  mac | the name of the MAC to use
  len | the output length of this filter. Leave the default value 0 if you want to use the full output of the MAC. Otherwise, specify a smaller value here so that the output of the MAC will be cut off.

Definition at line 105 of file algo_filt.cpp.

References Botan::Library_State::algorithm_factory(), Botan::Global_State_Management::global_state(), and Botan::Algorithm_Factory::make_mac().

105 :
106 OUTPUT_LENGTH(len)
107 {
108 Algorithm_Factory& af = global_state().algorithm_factory();
109 mac = af.make_mac(mac_name);
110 }
Botan::Library_State::algorithm_factory
Algorithm_Factory & algorithm_factory() const
Definition: libstate.cpp:173
Botan::Global_State_Management::global_state
Library_State & global_state()
Definition: global_state.cpp:32

## ◆ MAC_Filter() [4/4]

Botan::MAC_Filter::MAC_Filter | ( | const std::string & | mac,
|  | const SymmetricKey & | key,
|  | size_t | len = `0`
| ) |  |

Construct a MAC filter.

Parameters

  mac | the name of the MAC to use
  key | the MAC key to use
  len | the output length of this filter. Leave the default value 0 if you want to use the full output of the MAC. Otherwise, specify a smaller value here so that the output of the MAC will be cut off.

Definition at line 115 of file algo_filt.cpp.

References Botan::Library_State::algorithm_factory(), Botan::Global_State_Management::global_state(), Botan::Algorithm_Factory::make_mac(), and Botan::SymmetricAlgorithm::set_key().

116 : OUTPUT_LENGTH(len)
117 {
118 Algorithm_Factory& af = global_state().algorithm_factory();
119 mac = af.make_mac(mac_name);
120 mac->set_key(key);
121 }
Botan::Library_State::algorithm_factory
Algorithm_Factory & algorithm_factory() const
Definition: libstate.cpp:173
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60
Botan::Global_State_Management::global_state
Library_State & global_state()
Definition: global_state.cpp:32

## ◆ ~MAC_Filter()

Botan::MAC_Filter::~MAC_Filter | ( |  | ) |
| inline

Definition at line 217 of file filters.h.

217 { delete mac; }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

void Botan::MAC_Filter::end_msg | ( |  | ) |
| virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 126 of file algo_filt.cpp.

References Botan::Buffered_Computation::final(), Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

127 {
128 SecureVector<byte> output = mac->final();
129 if(OUTPUT_LENGTH)
130 send(output, std::min<size_t>(OUTPUT_LENGTH, output.size()));
131 else
132 send(output);
133 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::Buffered_Computation::final
void final(byte out[])
Definition: buf_comp.h:80

## ◆ name()

std::string Botan::MAC_Filter::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 148 of file filters.h.

148 { return mac->name(); }
Botan::MessageAuthenticationCode::name
virtual std::string name() const =0

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::Filter::end_msg(), Botan::MemoryRegion< T >::size(), Botan::Filter::start_msg(), and Botan::Filter::write().

Referenced by Botan::Base64_Encoder::Base64_Encoder(), Botan::EAX_Decryption::EAX_Decryption(), Botan::PK_Encryptor_Filter::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::PBE_PKCS5v15::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PBE_PKCS5v20::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Hex_Encoder::Hex_Encoder(), Botan::ECB_Encryption::name(), Botan::EAX_Base::name(), Botan::ECB_Decryption::name(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), Botan::CTS_Decryption::set_iv(), Botan::CBC_Decryption::set_iv(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:152
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ set_iv()

void Botan::Keyed_Filter::set_iv | ( | const InitializationVector & | iv | ) |
| virtualinherited

Set the initialization vector of this filter. Note: you should call set_iv() only after you have called set_key()

Parameters

  iv | the initialization vector to use

Reimplemented in Botan::CBC_Decryption, Botan::XTS_Decryption, Botan::CTS_Decryption, Botan::CFB_Decryption, Botan::StreamCipher_Filter, Botan::CBC_Encryption, Botan::EAX_Base, Botan::XTS_Encryption, Botan::CFB_Encryption, and Botan::CTS_Encryption.

Definition at line 13 of file basefilt.cpp.

References Botan::OctetString::length(), and Botan::Filter::name().

Referenced by Botan::get_cipher().

14 {
15 if(iv.length() != 0)
16 throw Invalid_IV_Length(name(), iv.length());
17 }
Botan::Filter::name
virtual std::string name() const =0

## ◆ set_key()

void Botan::MAC_Filter::set_key | ( | const SymmetricKey & | key | ) |
| inlinevirtual

Set the key of this filter.

Parameters

  key | the key to set

Implements Botan::Keyed_Filter.

Definition at line 154 of file filters.h.

154 { mac->set_key(key); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

Referenced by Botan::Filter::send().

38 {}

## ◆ valid_iv_length()

virtual bool Botan::Keyed_Filter::valid_iv_length | ( | size_t | length | ) | const
| inlinevirtualinherited

Check whether an IV length is valid for this filter

Parameters

  length | the IV length to be checked for validity

Returns
  true if the IV length is valid, false otherwise

Reimplemented in Botan::CBC_Decryption, Botan::XTS_Decryption, Botan::CTS_Decryption, Botan::CFB_Decryption, Botan::StreamCipher_Filter, Botan::EAX_Base, Botan::CBC_Encryption, Botan::CFB_Encryption, Botan::CTS_Encryption, and Botan::XTS_Encryption.

Definition at line 48 of file key_filt.h.

49 { return (length == 0); }

## ◆ valid_keylength()

bool Botan::MAC_Filter::valid_keylength | ( | size_t | length | ) | const
| inlinevirtual

Check whether a key length is valid for this filter.

Parameters

  length | the key length to be checked for validity

Returns
  true if the key length is valid, false otherwise

Implements Botan::Keyed_Filter.

Definition at line 161 of file filters.h.

162 { return mac->valid_keylength(length); }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51

## ◆ write()

void Botan::MAC_Filter::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| inlinevirtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 145 of file filters.h.

145 { mac->update(input, len); }
Botan::Buffered_Computation::update
void update(const byte in[], size_t length)
Definition: buf_comp.h:33

The documentation for this class was generated from the following files:

- src/filters/filters.h
- src/filters/algo_filt.cpp